/*
 * Sloggi - A Solaris Uname Jacket - http://www.roqe.org/sloggi
 * Copyright 2002 Konrad Rieck <kr@roqe.org> - All rights reserved. 
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright   
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright   
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR `AS IS'' AND ANY EXPRESS OR     
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. 
 * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
 * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY   
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#ifndef _SLUGGY_H
#define _SLUGGY_H

#define SYS_UNUSED -1
#define DFLT_ARG -1

#ifdef DEBUG
#define dcmn_err(X) cmn_err X
#else
#define dcmn_err(X)
#endif

/*
 * Intercepted syscalls
 */
enum syscall_id { UNAME = 0 };


/*
 * Structure for the syscall redirection
 */
typedef struct syscall_tab {

    int64_t(*sc) ();		/* Original syscall address */
    int64_t(*nc) ();		/* New syscall address */

#ifdef _LP64
    unsigned short flags;	/* Flags */
#else
    unsigned char flags;
#endif
    int index;			/* Syscall index */
    char narg;			/* Number of arguments, -1 = keep default */
    char onarg;			/* Original value */
} syscall_tab_t;


/* 
 * Sloggi syscall definitions
 */
int64_t uname_jacket(struct utsname *name);


#endif				/* _SLUGGY_H */
